/*++

Copyright (c) 1996  Microsoft Corporation

Module Name:

    pstub.c

Abstract:

    Stubs for protocol routines

Author:

    Jim Mateer 4-1-97

Environment:

    Kernel Mode

Revision History:

--*/

#include "ImSamp.h"

#pragma hdrstop

VOID
CLResetComplete(
    IN  NDIS_HANDLE ProtocolBindingContext,
    IN  NDIS_STATUS Status
    );


VOID
CLResetComplete(
    IN  NDIS_HANDLE ProtocolBindingContext,
    IN  NDIS_STATUS Status
    )

/*++

Routine Description:

    Completion routine for NdisReset

Arguments:

    See the DDK...

Return Values:

    None

--*/

{
    PADAPTER Adapter = (PADAPTER)ProtocolBindingContext;

    IMStructAssert( Adapter );

    ImDbgOut(DBG_TRACE, DBG_PROTOCOL, ("(%08X) CLResetComplete: Status = %08x\n",
                                       Adapter, Status));
}

/* end pstub.c */
